/*
	Installation script 
		for CopyModel add-in
			for Project Server 2003 Web Access

	(c) Bogdanov & Associates, 2004
*/

var debug = false; /* Set to 'true' to enable debug messages during installation */ 
var wsh = WScript.CreateObject("Wscript.Shell");
var fso = WScript.CreateObject("Scripting.FileSystemObject");


// Reading destination path (default used if not specified)

var destDir = "C:\\Program Files\\Microsoft Project\\IIS Virtual Root";
// Using directory
destDir = wsh.RegRead("HKLM\\Software\\Microsoft\\Office\\11.0\\MS Project\\Services\\Configuration\\Views Notification\\Directory")
destDir = fso.GetParentFolderName(fso.GetParentFolderName(destDir));
destDir += "\\IIS Virtual Root";
// Override by command line argument
if (WScript.Arguments.unnamed.count!=0) 
	destDir = WScript.Arguments.unnamed.item(0);
if (debug) WScript.Echo("Destination folder: " + destDir);


// Checking destination folder existance

try 
{
	var dir = fso.GetFolder(destDir);
} 
catch (e)
{
	WScript.Echo("Error checking destination directory '" + destDir + "':\n" + e.description);
	WScript.Quit(1);
}


// Checking destination folder contents (look for MODELS.ASP file)

try 
{
	var file = fso.GetFile(destDir + "\\MODELING\\models.asp");
}
catch(e)
{
	WScript.Echo("Error checking destination directory contents:\nError returned when opening file '" + destDir + "\\MODELING\\models.asp" + "':\n" + e.description + "\n\nTarget folder does not contain ProjectWebAccess files");
	WScript.Quit(1);
}


// Working!!!

var srcDir = WScript.ScriptFullName.slice(0, -1-WScript.ScriptName.length);
if (debug) WScript.Echo("Source folder: " + srcDir);

if (debug) WScript.Echo("Ready to copy")

// Creating backup copy of MODELS.asp
try
{
	fso.CopyFile(destDir + "\\MODELING\\models.asp", destDir + "\\MODELING\\models.CopyModelBackup.asp", false);
}
catch(e)
{}
try
{
	fso.CopyFile(destDir + "\\MODELING\\modeler.asp", destDir + "\\MODELING\\modeler.CopyModelBackup.asp", false);
}
catch(e)
{}

// Overwriting all other files
fso.CopyFile(srcDir+ "\\IISVirtualRoot_MODELING\\baCSessionEx.inc", destDir + "\\MODELING\\baCSessionEx.inc", true);
fso.CopyFile(srcDir+ "\\IISVirtualRoot_MODELING\\baHttpRds.asp", destDir + "\\MODELING\\baHttpRds.asp", true);
fso.CopyFile(srcDir+ "\\IISVirtualRoot_MODELING\\baHttpRds.js", destDir + "\\MODELING\\baHttpRds.js", true);
fso.CopyFile(srcDir+ "\\IISVirtualRoot_MODELING\\models.asp", destDir + "\\MODELING\\models.asp", true);
fso.CopyFile(srcDir+ "\\IISVirtualRoot_MODELING\\modeler.asp", destDir + "\\MODELING\\modeler.asp", true);

var destDir = fso.GetParentFolderName(destDir);
if (debug) WScript.Echo("BIN folder: " + destDir);
fso.CopyFile(srcDir+ "\\ProjectServer_BIN\\baPJWMS.dll", destDir + "\\BIN\\baPJWMS.dll", true);

// Registering DLL
var ret = wsh.Run("regsvr32 \"" + destDir + "\\BIN\\baPJWMS.dll" + "\"", 1, true);

if (ret == 0)
	wsh.Run(".\\baLChecker\\_install.js");
else
	WScript.Echo("Failed, REGSVR32 return code = " + ret + " and " + ret2);
